org.apache.poi.ddf

## Class EscherChildAnchorRecord

- java.lang.Object
- - org.apache.poi.ddf.EscherRecord
  - - org.apache.poi.ddf.EscherChildAnchorRecord

- All Implemented Interfaces:
    Duplicatable, GenericRecord

      public class EscherChildAnchorRecord
      extends EscherRecord

  The escher child achor record is used to specify the position of a shape under an existing group. The first level of shape records use a EscherClientAnchor record instead.
  See Also:
    `EscherChildAnchorRecord`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static short` | `RECORD_ID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EscherChildAnchorRecord()`
    `EscherChildAnchorRecord(EscherChildAnchorRecord other)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `EscherChildAnchorRecord` | `copy()`
    `int` | `fillFields(byte[] data, int offset, EscherRecordFactory recordFactory)` The contract of this method is to deserialize an escher record including it's children.
    `int` | `getDx1()` Retrieves offset within the parent coordinate space for the top left point.
    `int` | `getDx2()` Retrieves offset within the parent coordinate space for the bottom right point.
    `int` | `getDy1()` Gets offset within the parent coordinate space for the top left point.
    `int` | `getDy2()` Gets the offset within the parent coordinate space for the bottom right point.
    `java.util.Map<java.lang.String,java.util.function.Supplier<?>>` | `getGenericProperties()`
    `java.lang.Enum` | `getGenericRecordType()`
    `short` | `getRecordId()` Return the current record id.
    `java.lang.String` | `getRecordName()` Subclasses should return the short name for this escher record.
    `int` | `getRecordSize()` Subclasses should effeciently return the number of bytes required to serialize the record.
    `int` | `serialize(int offset, byte[] data, EscherSerializationListener listener)` Serializes the record to an existing byte array.
    `void` | `setDx1(int field_1_dx1)` Sets offset within the parent coordinate space for the top left point.
    `void` | `setDx2(int field_3_dx2)` Sets offset within the parent coordinate space for the bottom right point.
    `void` | `setDy1(int field_2_dy1)` Sets offset within the parent coordinate space for the top left point.
    `void` | `setDy2(int field_4_dy2)` Sets the offset within the parent coordinate space for the bottom right point.

    - ### Methods inherited from class org.apache.poi.ddf.EscherRecord

      `clone, display, fillFields, getChild, getChildRecords, getGenericChildren, getInstance, getOptions, getVersion, isContainerRecord, readHeader, readInstance, serialize, serialize, setChildRecords, setInstance, setOptions, setRecordId, setVersion, toString, toXml, toXml`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### RECORD_ID

          public static final short RECORD_ID

  - ### Constructor Detail

    - #### EscherChildAnchorRecord

          public EscherChildAnchorRecord()

    - #### EscherChildAnchorRecord

          public EscherChildAnchorRecord(EscherChildAnchorRecord other)

  - ### Method Detail

    - #### fillFields

          public int fillFields(byte[] data,
                                int offset,
                                EscherRecordFactory recordFactory)

      Description copied from class: `EscherRecord`
      The contract of this method is to deserialize an escher record including it's children.
      Specified by:
        `fillFields` in class `EscherRecord`
      Parameters:
        `data` - The byte array containing the serialized escher records.
        `offset` - The offset into the byte array.
        `recordFactory` - A factory for creating new escher records.
      Returns:
        The number of bytes written.

    - #### serialize

          public int serialize(int offset,
                               byte[] data,
                               EscherSerializationListener listener)

      Description copied from class: `EscherRecord`
      Serializes the record to an existing byte array.
      Specified by:
        `serialize` in class `EscherRecord`
      Parameters:
        `offset` - the offset within the byte array
        `data` - the data array to serialize to
        `listener` - a listener for begin and end serialization events. This is useful because the serialization is hierarchical/recursive and sometimes you need to be able break into that.
      Returns:
        the number of bytes written.

    - #### getRecordSize

          public int getRecordSize()

      Description copied from class: `EscherRecord`
      Subclasses should effeciently return the number of bytes required to serialize the record.
      Specified by:
        `getRecordSize` in class `EscherRecord`
      Returns:
        number of bytes

    - #### getRecordId

          public short getRecordId()

      Description copied from class: `EscherRecord`
      Return the current record id.
      Overrides:
        `getRecordId` in class `EscherRecord`
      Returns:
        The 16 bit record id.

    - #### getRecordName

          public java.lang.String getRecordName()

      Description copied from class: `EscherRecord`
      Subclasses should return the short name for this escher record.
      Specified by:
        `getRecordName` in class `EscherRecord`
      Returns:
        the short name for this escher record

    - #### getDx1

          public int getDx1()

      Retrieves offset within the parent coordinate space for the top left point.
      Returns:
        the x offset of the top left point

    - #### setDx1

          public void setDx1(int field_1_dx1)

      Sets offset within the parent coordinate space for the top left point.
      Parameters:
        `field_1_dx1` - the x offset of the top left point

    - #### getDy1

          public int getDy1()

      Gets offset within the parent coordinate space for the top left point.
      Returns:
        the y offset of the top left point

    - #### setDy1

          public void setDy1(int field_2_dy1)

      Sets offset within the parent coordinate space for the top left point.
      Parameters:
        `field_2_dy1` - the y offset of the top left point

    - #### getDx2

          public int getDx2()

      Retrieves offset within the parent coordinate space for the bottom right point.
      Returns:
        the x offset of the bottom right point

    - #### setDx2

          public void setDx2(int field_3_dx2)

      Sets offset within the parent coordinate space for the bottom right point.
      Parameters:
        `field_3_dx2` - the x offset of the bottom right point

    - #### getDy2

          public int getDy2()

      Gets the offset within the parent coordinate space for the bottom right point.
      Returns:
        the y offset of the bottom right point

    - #### setDy2

          public void setDy2(int field_4_dy2)

      Sets the offset within the parent coordinate space for the bottom right point.
      Parameters:
        `field_4_dy2` - the y offset of the bottom right point

    - #### getGenericProperties

          public java.util.Map<java.lang.String,java.util.function.Supplier<?>> getGenericProperties()

      Specified by:
        `getGenericProperties` in interface `GenericRecord`
      Overrides:
        `getGenericProperties` in class `EscherRecord`

    - #### getGenericRecordType

          public java.lang.Enum getGenericRecordType()

    - #### copy

          public EscherChildAnchorRecord copy()

      Specified by:
        `copy` in interface `Duplicatable`
      Specified by:
        `copy` in class `EscherRecord`
      Returns:
        a deep copy of the implementing class / instance

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.